/**
 * EN.java
 *
 * File generated from the medication::EN uml Class
 * Generated by IHE - europe, gazelle team
 */
package net.ihe.gazelle.medication;

import java.util.ArrayList;
import java.util.List;

import javax.xml.bind.JAXBContext;
import javax.xml.bind.JAXBElement;
import javax.xml.bind.JAXBException;
import javax.xml.bind.Marshaller;
import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlAttribute;
import javax.xml.bind.annotation.XmlElementRef;
import javax.xml.bind.annotation.XmlElementRefs;
import javax.xml.bind.annotation.XmlMixed;
import javax.xml.bind.annotation.XmlRootElement;
import javax.xml.bind.annotation.XmlTransient;
import javax.xml.bind.annotation.XmlType;
import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.ParserConfigurationException;

import org.w3c.dom.Document;
import org.w3c.dom.Node;

import net.ihe.gazelle.gen.common.ConstraintValidatorModule;


/**
 * Description of the class EN.
 *
 * 
 */

@XmlAccessorType(XmlAccessType.FIELD)
@XmlType(name = "EN", propOrder = {
	"mixed",
	"use"
})
@XmlRootElement(name = "EN")
public class EN extends net.ihe.gazelle.medication.ANY implements java.io.Serializable {
	
	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;

	
	@XmlElementRefs({
			@XmlElementRef(name = "delimiter", namespace = "urn:epsos-org:ep:medication", type = JAXBElement.class),
			@XmlElementRef(name = "family", namespace = "urn:epsos-org:ep:medication", type = JAXBElement.class),
			@XmlElementRef(name = "given", namespace = "urn:epsos-org:ep:medication", type = JAXBElement.class),
			@XmlElementRef(name = "prefix", namespace = "urn:epsos-org:ep:medication", type = JAXBElement.class),
			@XmlElementRef(name = "suffix", namespace = "urn:epsos-org:ep:medication", type = JAXBElement.class),
			@XmlElementRef(name = "validTime", namespace = "urn:epsos-org:ep:medication", type = JAXBElement.class)
		})
		@XmlMixed
	public List<java.io.Serializable> mixed;
	/**
	 *                       A set of codes advising a system or
	                            user which name                      in a set of like names to select
	                            for a given purpose.                      A name without specific use
	                            code might be a default                      name useful for any
	                            purpose, but a name with a specific                      use code would
	                            be preferred for that respective purpose.
	                        .
	 */
	@XmlAttribute(name = "use")
	public java.lang.String use;
	
	/**
	 * An attribute containing marshalled element node
	 */
	@XmlTransient
	private org.w3c.dom.Node _xmlNodePresentation;
	
	
	/**
	 * Return mixed.
	 * @return mixed
	 */
	public List<java.io.Serializable> getMixed() {
		if (mixed == null) {
	        mixed = new ArrayList<java.io.Serializable>();
	    }
	    return mixed;
	}
	
	/**
	 * Set a value to attribute mixed.
	 * @param mixed.
	 */
	public void setMixed(List<java.io.Serializable> mixed) {
	    this.mixed = mixed;
	}
	
	
	
	/**
	 * Add a mixed to the mixed collection.
	 * @param mixed_elt Element to add.
	 */
	public void addMixed(java.io.Serializable mixed_elt) {
	    this.mixed.add(mixed_elt);
	}
	
	/**
	 * Remove a mixed to the mixed collection.
	 * @param mixed_elt Element to remove
	 */
	public void removeMixed(java.io.Serializable mixed_elt) {
	    this.mixed.remove(mixed_elt);
	}
	
	
	/**
	 * Return delimiter.
	 * @return delimiter
	 */
	public List<net.ihe.gazelle.medication.EnDelimiter> getDelimiter() {
		List<net.ihe.gazelle.medication.EnDelimiter> delimiter_el = new ArrayList<net.ihe.gazelle.medication.EnDelimiter>();
			for(java.io.Serializable obj : this.getMixed()){
			if (obj instanceof javax.xml.bind.JAXBElement){
				if (((javax.xml.bind.JAXBElement<?>)obj).getName().getLocalPart().equals("delimiter")){
					delimiter_el.add( (net.ihe.gazelle.medication.EnDelimiter) ((javax.xml.bind.JAXBElement<?>)obj).getValue() );
				}
			}
		} 

	    return delimiter_el;
	}
	
	public void addDelimiter(net.ihe.gazelle.medication.EnDelimiter obj){
		ObjectFactory of = new ObjectFactory();
		JAXBElement<net.ihe.gazelle.medication.EnDelimiter> jobj = of.createENDelimiter(obj);
		this.getMixed().add(jobj);
	}
	
	
	/**
	 * Return family.
	 * @return family
	 */
	public List<net.ihe.gazelle.medication.EnFamily> getFamily() {
		List<net.ihe.gazelle.medication.EnFamily> family_el = new ArrayList<net.ihe.gazelle.medication.EnFamily>();
			for(java.io.Serializable obj : this.getMixed()){
			if (obj instanceof javax.xml.bind.JAXBElement){
				if (((javax.xml.bind.JAXBElement<?>)obj).getName().getLocalPart().equals("family")){
					family_el.add( (net.ihe.gazelle.medication.EnFamily) ((javax.xml.bind.JAXBElement<?>)obj).getValue() );
				}
			}
		} 

	    return family_el;
	}
	
	public void addFamily(net.ihe.gazelle.medication.EnFamily obj){
		ObjectFactory of = new ObjectFactory();
		JAXBElement<net.ihe.gazelle.medication.EnFamily> jobj = of.createENFamily(obj);
		this.getMixed().add(jobj);
	}
	
	
	/**
	 * Return given.
	 * @return given
	 */
	public List<net.ihe.gazelle.medication.EnGiven> getGiven() {
		List<net.ihe.gazelle.medication.EnGiven> given_el = new ArrayList<net.ihe.gazelle.medication.EnGiven>();
			for(java.io.Serializable obj : this.getMixed()){
			if (obj instanceof javax.xml.bind.JAXBElement){
				if (((javax.xml.bind.JAXBElement<?>)obj).getName().getLocalPart().equals("given")){
					given_el.add( (net.ihe.gazelle.medication.EnGiven) ((javax.xml.bind.JAXBElement<?>)obj).getValue() );
				}
			}
		} 

	    return given_el;
	}
	
	public void addGiven(net.ihe.gazelle.medication.EnGiven obj){
		ObjectFactory of = new ObjectFactory();
		JAXBElement<net.ihe.gazelle.medication.EnGiven> jobj = of.createENGiven(obj);
		this.getMixed().add(jobj);
	}
	
	
	/**
	 * Return prefix.
	 * @return prefix
	 */
	public List<net.ihe.gazelle.medication.EnPrefix> getPrefix() {
		List<net.ihe.gazelle.medication.EnPrefix> prefix_el = new ArrayList<net.ihe.gazelle.medication.EnPrefix>();
			for(java.io.Serializable obj : this.getMixed()){
			if (obj instanceof javax.xml.bind.JAXBElement){
				if (((javax.xml.bind.JAXBElement<?>)obj).getName().getLocalPart().equals("prefix")){
					prefix_el.add( (net.ihe.gazelle.medication.EnPrefix) ((javax.xml.bind.JAXBElement<?>)obj).getValue() );
				}
			}
		} 

	    return prefix_el;
	}
	
	public void addPrefix(net.ihe.gazelle.medication.EnPrefix obj){
		ObjectFactory of = new ObjectFactory();
		JAXBElement<net.ihe.gazelle.medication.EnPrefix> jobj = of.createENPrefix(obj);
		this.getMixed().add(jobj);
	}
	
	
	/**
	 * Return suffix.
	 * @return suffix
	 */
	public List<net.ihe.gazelle.medication.EnSuffix> getSuffix() {
		List<net.ihe.gazelle.medication.EnSuffix> suffix_el = new ArrayList<net.ihe.gazelle.medication.EnSuffix>();
			for(java.io.Serializable obj : this.getMixed()){
			if (obj instanceof javax.xml.bind.JAXBElement){
				if (((javax.xml.bind.JAXBElement<?>)obj).getName().getLocalPart().equals("suffix")){
					suffix_el.add( (net.ihe.gazelle.medication.EnSuffix) ((javax.xml.bind.JAXBElement<?>)obj).getValue() );
				}
			}
		} 

	    return suffix_el;
	}
	
	public void addSuffix(net.ihe.gazelle.medication.EnSuffix obj){
		ObjectFactory of = new ObjectFactory();
		JAXBElement<net.ihe.gazelle.medication.EnSuffix> jobj = of.createENSuffix(obj);
		this.getMixed().add(jobj);
	}
	
	
	/**
	 * Return validTime.
	 * @return validTime
	 */
	public net.ihe.gazelle.medication.IVLTS getValidTime() {
		net.ihe.gazelle.medication.IVLTS validTime_el = null;
			for(java.io.Serializable obj : this.getMixed()){
			if (obj instanceof javax.xml.bind.JAXBElement){
				if (((javax.xml.bind.JAXBElement<?>)obj).getName().getLocalPart().equals("validTime")){
					validTime_el = (net.ihe.gazelle.medication.IVLTS) ((javax.xml.bind.JAXBElement<?>)obj).getValue();
					return validTime_el;
				}
			}
		} 

	    return validTime_el;
	}
	
	public void addValidTime(net.ihe.gazelle.medication.IVLTS obj){
		ObjectFactory of = new ObjectFactory();
		JAXBElement<net.ihe.gazelle.medication.IVLTS> jobj = of.createENValidTime(obj);
		this.getMixed().add(jobj);
	}
	
	
	/**
	 * Return use.
	 * @return use :                       A set of codes advising a system or
	                            user which name                      in a set of like names to select
	                            for a given purpose.                      A name without specific use
	                            code might be a default                      name useful for any
	                            purpose, but a name with a specific                      use code would
	                            be preferred for that respective purpose.
	                                              A set of codes advising a system or
	                            user which name                      in a set of like names to select
	                            for a given purpose.                      A name without specific use
	                            code might be a default                      name useful for any
	                            purpose, but a name with a specific                      use code would
	                            be preferred for that respective purpose.
	                                              A set of codes advising a system or
	                            user which name                      in a set of like names to select
	                            for a given purpose.                      A name without specific use
	                            code might be a default                      name useful for any
	                            purpose, but a name with a specific                      use code would
	                            be preferred for that respective purpose.
	                                              A set of codes advising a system or
	                            user which name                      in a set of like names to select
	                            for a given purpose.                      A name without specific use
	                            code might be a default                      name useful for any
	                            purpose, but a name with a specific                      use code would
	                            be preferred for that respective purpose.
	                                              A set of codes advising a system or
	                            user which name                      in a set of like names to select
	                            for a given purpose.                      A name without specific use
	                            code might be a default                      name useful for any
	                            purpose, but a name with a specific                      use code would
	                            be preferred for that respective purpose.
	                                              A set of codes advising a system or
	                            user which name                      in a set of like names to select
	                            for a given purpose.                      A name without specific use
	                            code might be a default                      name useful for any
	                            purpose, but a name with a specific                      use code would
	                            be preferred for that respective purpose.
	                                              A set of codes advising a system or
	                            user which name                      in a set of like names to select
	                            for a given purpose.                      A name without specific use
	                            code might be a default                      name useful for any
	                            purpose, but a name with a specific                      use code would
	                            be preferred for that respective purpose.
	                        
	 */
	public java.lang.String getUse() {
	    return use;
	}
	
	/**
	 * Set a value to attribute use.
	 * @param use :                       A set of codes advising a system or
	                            user which name                      in a set of like names to select
	                            for a given purpose.                      A name without specific use
	                            code might be a default                      name useful for any
	                            purpose, but a name with a specific                      use code would
	                            be preferred for that respective purpose.
	                                              A set of codes advising a system or
	                            user which name                      in a set of like names to select
	                            for a given purpose.                      A name without specific use
	                            code might be a default                      name useful for any
	                            purpose, but a name with a specific                      use code would
	                            be preferred for that respective purpose.
	                                              A set of codes advising a system or
	                            user which name                      in a set of like names to select
	                            for a given purpose.                      A name without specific use
	                            code might be a default                      name useful for any
	                            purpose, but a name with a specific                      use code would
	                            be preferred for that respective purpose.
	                                              A set of codes advising a system or
	                            user which name                      in a set of like names to select
	                            for a given purpose.                      A name without specific use
	                            code might be a default                      name useful for any
	                            purpose, but a name with a specific                      use code would
	                            be preferred for that respective purpose.
	                                              A set of codes advising a system or
	                            user which name                      in a set of like names to select
	                            for a given purpose.                      A name without specific use
	                            code might be a default                      name useful for any
	                            purpose, but a name with a specific                      use code would
	                            be preferred for that respective purpose.
	                                              A set of codes advising a system or
	                            user which name                      in a set of like names to select
	                            for a given purpose.                      A name without specific use
	                            code might be a default                      name useful for any
	                            purpose, but a name with a specific                      use code would
	                            be preferred for that respective purpose.
	                                              A set of codes advising a system or
	                            user which name                      in a set of like names to select
	                            for a given purpose.                      A name without specific use
	                            code might be a default                      name useful for any
	                            purpose, but a name with a specific                      use code would
	                            be preferred for that respective purpose.
	                        .
	 */
	public void setUse(java.lang.String use) {
	    this.use = use;
	}
	
	
	
	
	
	public Node get_xmlNodePresentation() {
		if (_xmlNodePresentation == null){
				JAXBContext jc;
				DocumentBuilderFactory dbf = DocumentBuilderFactory.newInstance();
				dbf.setNamespaceAware(true);
				DocumentBuilder db = null;
				Document doc = null;
				try {
					db = dbf.newDocumentBuilder();
					doc = db.newDocument();
				} catch (ParserConfigurationException e1) {}
				try {
					jc = JAXBContext.newInstance("net.ihe.gazelle.medication");
					Marshaller m = jc.createMarshaller();
					m.marshal(this, doc);
					_xmlNodePresentation = doc.getElementsByTagNameNS("urn:epsos-org:ep:medication", "EN").item(0);
				} catch (JAXBException e) {
					try{
						db = dbf.newDocumentBuilder();
						_xmlNodePresentation = db.newDocument();
					}
					catch(Exception ee){}
				}
			}
			return _xmlNodePresentation;
	}
	
	public void set_xmlNodePresentation(Node _xmlNodePresentation) {
		this._xmlNodePresentation = _xmlNodePresentation;
	}
	
	
	public List<String> getListStringValues(){
		List<String> res = new ArrayList<String>();
		for(java.io.Serializable obj : this.getMixed()){
			if (obj instanceof String){
				res.add((String)obj);
			}
		} 
		return res;
	}
	

	
	/**
     * validate by a module of validation
     * 
     */
   public static void validateByModule(EN eN, String location, ConstraintValidatorModule cvm, List<net.ihe.gazelle.validation.Notification> diagnostic){
   		if (eN != null){
   			net.ihe.gazelle.medication.ANY.validateByModule(eN, location, cvm, diagnostic);
			{
				int i = 0;
				for (net.ihe.gazelle.medication.EnDelimiter delimiter: eN.getDelimiter()){
					net.ihe.gazelle.medication.EnDelimiter.validateByModule(delimiter, location + "/delimiter[" + i + "]", cvm, diagnostic);
					i++;
				}
			}
			
			{
				int i = 0;
				for (net.ihe.gazelle.medication.EnFamily family: eN.getFamily()){
					net.ihe.gazelle.medication.EnFamily.validateByModule(family, location + "/family[" + i + "]", cvm, diagnostic);
					i++;
				}
			}
			
			{
				int i = 0;
				for (net.ihe.gazelle.medication.EnGiven given: eN.getGiven()){
					net.ihe.gazelle.medication.EnGiven.validateByModule(given, location + "/given[" + i + "]", cvm, diagnostic);
					i++;
				}
			}
			
			{
				int i = 0;
				for (net.ihe.gazelle.medication.EnPrefix prefix: eN.getPrefix()){
					net.ihe.gazelle.medication.EnPrefix.validateByModule(prefix, location + "/prefix[" + i + "]", cvm, diagnostic);
					i++;
				}
			}
			
			{
				int i = 0;
				for (net.ihe.gazelle.medication.EnSuffix suffix: eN.getSuffix()){
					net.ihe.gazelle.medication.EnSuffix.validateByModule(suffix, location + "/suffix[" + i + "]", cvm, diagnostic);
					i++;
				}
			}
			
			net.ihe.gazelle.medication.IVLTS.validateByModule(eN.getValidTime(), location + "/validTime", cvm, diagnostic);
    	}
    }

}